/***************************************************************************
                          kbattleshipdoc.h  -  description
                             -------------------
    begin                : dom dic 12 21:31:30 CET 1999
    copyright            : (C) 1999 by Alessandro Praduroux
    email                : pradu@tiscalinet.it
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KBATTLESHIPDOC_H
#define KBATTLESHIPDOC_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif 

// include files for QT
#include <qobject.h>
#include <qstring.h>
#include <qlist.h>

//application specific includes
#include "kbattleshipdocbase.h"

// forward declaration of the KBattleship classes
class KBattleshipViewBase;

/**	KBattleshipDoc provides a document object for a document-view model.
  *
  * The KBattleshipDoc class provides a document object that can be used in conjunction with the classes KBattleshipApp and KBattleshipView
  * to create a document-view model for standard KDE applications based on KApplication and KTMainWindow. Thereby, the document object
  * is created by the KBattleshipApp instance and contains the document structure with the according methods for manipulation of the document
  * data by KBattleshipView objects. Also, KBattleshipDoc contains the methods for serialization of the document data from and to files.
  *
  * @author Source Framework Automatically Generated by KDevelop, (c) The KDevelop Team. 	
  * @version KDevelop version 0.4 code generation
  */
class KBattleshipDoc : public QObject
{
  Q_OBJECT
  public:
    /** Constructor for the fileclass of the application */
    KBattleshipDoc(QWidget *parent, const char *name=0);
    /** Destructor for the fileclass of the application */
    ~KBattleshipDoc();

    /** adds a view to the document which represents the document contents. Usually this is your main view. */
    void addView(KBattleshipViewBase *view);
    /** removes a view from the list of currently connected views */
    void removeView(KBattleshipViewBase *view);
    /** sets the modified flag for the document after a modifying action on the view connected to the document.*/
    void setModified(bool _m=true){ modified=_m; };
    /** returns if the document is modified or not. Use this to determine if your document needs saving by the user on closing.*/
    bool isModified(){ return modified; };
    /** "save modified" - asks the user for saving if the document is modified */
    bool saveModified();	
    /** deletes the document's contents */
    void deleteContents();
    /** initializes the document generally */
    bool newDocument(QString server = "");
    /** closes the acutal document */
    void closeDocument();
    /** loads the document by filename and format and emits the updateViews() signal */
    bool openDocument(const QString &filename, const char *format=0);
    /** saves the document under filename and format.*/	
    bool saveDocument(const QString &filename, const char *format=0);
    /** sets the path to the file connected with the document */
    void setAbsFilePath(const QString &filename);
    /** returns the pathname of the current document file*/
    const QString &getAbsFilePath() const;
    /** sets the filename of the document */
    void setTitle(const QString &_t);
    /** returns the title of the document */
    const QString getTitle() const;
		/** returns the base document */
    KBattleshipDocBase * getDocBase();	
  /**  */

  public slots:
    /** calls repaint() on all views connected to the document object and is called by the view by which the document has been changed.
     * As this view normally repaints itself, it is excluded from the paintEvent.
     */
    void slotUpdateAllViews(KBattleshipViewBase *sender);
  /**  */
  void slotDataChanged();
 	
  public:	
    /** the list of the views currently connected to the document */
    static QList<KBattleshipViewBase> *pViewList;	

  private:
    /** the modified flag of the current document */
    bool modified;
    QString title;
    QString absFilePath;

protected: // Protected attributes
  /** this is the name of your enemy's fleet */
  QString enemyName;

  /** this class is the real document, the class
   * KBattleshipDoc is just a wrapper that forwards to this
   */
  KBattleshipDocBase * base;
};

#endif // KBATTLESHIPDOC_H
